#!/usr/bin/python
from ursina import *
from ursina.prefabs.first_person_controller import FirstPersonController
from ursina.shaders import lit_with_shadows_shader
import random2


class Footballer(Entity):
    def __init__(self,team,defender,id,**kwargs):
        super().__init__(**kwargs)
        self.team = team
        self.defender = defender
        self.id = id
        self.has_ball = False
        self.old_x = 0
        self.old_z = 0
        self.speed = random.randint(1,3)/500
        self.speed = random.randint(3,5)/500
        self.original_speed = self.speed
        self.original_position = self.position
        if self.team == 1:
            self.soldier = BritishSoldier(model='british_soldier_uniform',texture='british_uniform',scale=1,position=self.position,shader=lit_with_shadows_shader)
        if self.team == 2:
            self.soldier = GermanSoldier(model='german_soldier_uniform',texture='german_torso',scale=1,position=self.position,shader=lit_with_shadows_shader)

    def football_player(self,footballer):
        global player, ball, ball_place_to_go_to, ball_going_to_player, football_goal_british, football_goal_germans, ultimate_ball
        if not footballer.id == self.id:
            if self.defender:
                if self.has_ball and footballer.team == self.team and not footballer.defender:
                    ball_going_to_player = True
                    ball_place_to_go_to.position = footballer.position
                if footballer.has_ball and not footballer.team == self.team:
                    if footballer.x-9 < self.x < footballer.x+9 and footballer.z-9 < self.z < footballer.z+9:
                        self.speed = self.original_speed * 4
                        if self.x > footballer.x:
                            self.x -= self.speed
                        if self.x < footballer.x:
                            self.x += self.speed
                        if self.z > footballer.z:
                            self.z -= self.speed
                        if self.z < footballer.z:
                            self.z += self.speed
                        if self.x - 1.2 < footballer.x < self.x + 1.2 and self.z - 1.2 < footballer.z < self.z + 1.2:
                            ball.x = self.x
                            ball.z = self.z
            if not self.defender:
                if self.has_ball:
                    self.speed = self.original_speed * 1.5
                    if self.team == 1:
                        if self.x > football_goal_germans.x:
                            self.x -= self.speed
                        if self.x < football_goal_germans.x:
                            self.x += self.speed
                        if self.z > football_goal_germans.z:
                            self.z -= self.speed
                        if self.z < football_goal_germans.z:
                            self.z += self.speed
                    if self.team == 2:
                        if self.x > football_goal_british.x:
                            self.x -= self.speed
                        if self.x < football_goal_british.x:
                            self.x += self.speed
                        if self.z > football_goal_british.z:
                            self.z -= self.speed
                        if self.z < football_goal_british.z:
                            self.z += self.speed
                        if self.x - 4 < football_goal_british.x < self.x + 4 and self.z - 4 < football_goal_british.z < self.z + 4:
                            ultimate_ball = 20
                if not self.has_ball:
                    self.speed = self.original_speed
                    if not footballer.has_ball and not footballer.team == self.team:
                        if self.x > ball.x:
                            self.x -= self.speed
                        if self.x < ball.x:
                            self.x += self.speed
                        if self.z > ball.z:
                            self.z -= self.speed
                        if self.z < ball.z:
                            self.z += self.speed
                    if footballer.has_ball and not footballer.team == self.team:
                        if self.x > footballer.x:
                            self.x -= self.speed
                        if self.x < footballer.x:
                            self.x += self.speed
                        if self.z > footballer.z:
                            self.z -= self.speed
                        if self.z < footballer.z:
                            self.z += self.speed
                        if self.x - 2 < footballer.x < self.x + 2 and self.z - 2 < footballer.z < self.z + 2:
                            ball.x = self.x
                            ball.z = self.z

    def update(self):
        global player, ball, ball_speed_x, ball_speed_z, football_players, reset_positions_player, ultimate_ball
        self.look_at(ball)
        self.rotation_x = 0
        self.rotation_z = 0
        self.soldier.position = self.position
        self.soldier.rotation = self.rotation
        for footballer in football_players:
            self.football_player(footballer)
        if ball.x - 1.5 < self.x < ball.x + 1.5 and ball.z - 1.5 < self.z < ball.z + 1.5 and not ball_going_to_player:
            ball_speed_x = self.x - self.old_x
            ball_speed_z = self.z - self.old_z
            ball_speed_z = ball_speed_z * ultimate_ball
            ball_speed_x = ball_speed_x * ultimate_ball
            ultimate_ball = 1
            self.has_ball = True
            if self.x - 1 < player.x < self.x + 1 and self.z - 1 < player.z < self.z + 1:
                ball.x = player.x + 0.5 
                ball.z = player.z
                self.has_ball = False
        else:
            self.has_ball = False
        if reset_positions_player > 0:
            reset_positions_player -= 1
            self.position = self.original_position
        self.old_x = self.x
        self.old_z = self.z


class GermanSoldier(Entity):
    def __init__(self,**kwargs):
        super().__init__(**kwargs)
        self.head = Entity(model='german_soldier_head',texture='german_head',scale=self.scale,position=self.position,shader=lit_with_shadows_shader)
        self.hands = Entity(model='german_soldier_hands', texture='german_hands', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.helmet = Entity(model='german_soldier_helmet', texture='german_helmet', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.long = Entity(model='german_soldier_long', texture='german_long', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.pants = Entity(model='german_soldier_pants', texture='german_pants', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.boots = Entity(model='german_soldier_boots', texture='german_boots', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)

    def update(self):
        self.head.position = self.position
        self.hands.position = self.position
        self.helmet.position = self.position
        self.long.position = self.position
        self.pants.position = self.position
        self.boots.position = self.position
        self.head.rotation = self.rotation
        self.hands.rotation = self.rotation
        self.helmet.rotation = self.rotation
        self.long.rotation = self.rotation
        self.pants.rotation = self.rotation
        self.boots.rotation = self.rotation


class BritishSoldier(Entity):
    def __init__(self,**kwargs):
        super().__init__(**kwargs)
        self.head = Entity(model='british_soldierhead',texture='british_head',scale=self.scale,position=self.position,shader=lit_with_shadows_shader)
        self.hands = Entity(model='british_soldier_hands', texture='british_hands', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.helmet = Entity(model='british_soldier_helmet', texture='british_helmet', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.long = Entity(model='british_soldier_bag', texture='british_bag', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.pants = Entity(model='british_soldier_pants', texture='british_pants', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)
        self.boots = Entity(model='british_soldier_boots', texture='british_boots', scale=self.scale, position=self.position,shader=lit_with_shadows_shader)

    def update(self):
        self.head.position = self.position
        self.hands.position = self.position
        self.helmet.position = self.position
        self.long.position = self.position
        self.pants.position = self.position
        self.boots.position = self.position
        self.head.rotation = self.rotation
        self.hands.rotation = self.rotation
        self.helmet.rotation = self.rotation
        self.long.rotation = self.rotation
        self.pants.rotation = self.rotation
        self.boots.rotation = self.rotation

app = Ursina()
window.color = color.rgb(0, 0, 255)

key_2 = None
credits_text = '''soubory pod licencí Creative Commons:
    Vr-Cvantorium. Sketchfab [online]. [cit. 4.1.2025]. 
    Dostupný na WWW: https://sketchfab.com/3d-models/soldier-6746867266f04bf5aed3b4f0a6df278c
     - soubory začínající na german
    JAKELI, George. Sketchfab [online]. [cit. 4.1.2025]. 
    Dostupný na WWW: https://sketchfab.com/3d-models/british-army-soldier-ww2-c3d6038952914362b897138deda762ef
     - soubory začínající na british
                '''
controls_text = '''w - pohyb dopředu
                   a - pohyb doleva
                   s - pohyb dozádu
                   d - pohyb doprava
                   shift - běh
                   e - odejít od kulometu
                   enter - odklikávání textu (postava, která k vám mluví se přesune na další větu)
                   levý klik myší - stiskávání tlačítek, odkopnutí míče pokud ho máte
                   otáčení myší - otáčení postavy ve hře
                   esc - vypnutí hry
                    '''
start_button = Button(text='Hrát',scale=0.1,y=0.3)
controls_button = Button(text='Ovládání',scale=0.1,y=0)
exit_button = Button(text='Ukončit',scale=0.1,y=-0.3)
controls_list = Button(text=controls_text,scale=1,y=-50)
back_button = Button(text='Zpět',scale=0.1,y=-50,x=0.6)
credits_button = Button(text='Použité soubory',scale=0.1,y=0,x=-0.6)
credits_list = Button(text=credits_text,scale=1,y=-50)
starting_screen = Entity(model='starting_screen',texture='start_texture',y=0,rotation_y=-90,z=-5)
loading_text = Button(text='Načítání',scale=0.5,y=-50)
british_guy_text_1 = Button(text='Dobré ráno, dnes už jsou ty zasloužené Vánoce,',scale=0.1,y=-50)
british_guy_text_2 = Button(text='ale stejně abychom si byli jisti tak jdi k kulometu a hlídej (kliknutím na kulomet), aby sem nikdo nepřišel.',scale=0.1,y=-50)
british_guy_text_3 = Button(text='Já si konečně jdu napsat ten dopis domů, jak jsem o něm včera mluvil,',scale=0.1,y=-50)
british_guy_text_4 = Button(text='s tím jak to tu jde tak snad dojede k nám do Norwiche do února.',scale=0.1,y=-50)
german_guy_text_1 = Button(text='Počkej nestřílej, když už jsou ty Vánoce tak bychom se nemuseli střílet',scale=0.1,y=-50)
german_guy_text_2 = Button(text='Zahrajeme si fotbal proti sobě do 10 gólů',scale=0.1,y=-50)
self_text = Button(text='Neměl bych to dělat, má bílou vlajku',scale=0.1,y=-50)
british_end = Button(icon='end_flag_british',y=-50)
german_end = Button(icon='end_flag_german',y=-50)

game_cycle = False
generate = False
ground = None
ground_2 = None
ground_3 = None
sun = None
player = None
treeline = None
ball = None
ball_speed_x = 0
ball_speed_z = 0
old_player_x = 0
old_player_z = 0
german_goal = 0
british_goal = 0
goal_counter = Button(text='Britové:{}     Němci:{}'.format(british_goal,german_goal),scale=0.1,y=-100)
football_goal_british = None
football_goal_germans = None
football_players_id = 0
football_players = []
ball_going_to_player = False
ball_place_to_go_to = Entity(model='cube',visible=False)
reset_positions_player = 0
ultimate_ball = 1
machinegun_1 = None
machinegun_2 = None
sprinting = False
stamina = 100
football_start = False
football_started = False
british_guy = None
german_guy = None
generating = False
british_guy_monolog = 0
at_machine_gun = False
white_flag_1 = None
white_flag_2 = None
gunshot = Audio(sound_file_name='gunshots.mp3',autoplay=False)
walking = Audio(sound_file_name='walking.mp3',autoplay=False)
talking = Audio(sound_file_name='talking.mp3',autoplay=False)


def starting_scene():
    global british_guy, key_2, british_guy_monolog, british_guy_text_1, british_guy_text_2, british_guy_text_3, british_guy_text_4, german_guy, at_machine_gun
    global talking, gunshot, white_flag_1, white_flag_2, football_start
    if machinegun_1.hovered or machinegun_2.hovered:
        if key_2 == 'left mouse down':
            at_machine_gun = True
            key_2 = None
    if key_2 == 'enter':
        self_text.y = -50
    if at_machine_gun:
        player.x = machinegun_2.x
        player.z = machinegun_2.z + 0.5
        player.y = machinegun_2.y
        machinegun_2.rotation_y = player.rotation_y - 180
        if key_2 == 'e':
            at_machine_gun = False
        if key_2 == 'left mouse down':
            if german_guy.hovered:
                self_text.y = -0.4
            else:
                gunshot.play()
    if british_guy_monolog == 0:
        if british_guy.x < -4:
            british_guy.x += 0.04
            british_guy.y += 0.004
            british_guy.z += 0.002
        if british_guy.x >= -4:
            if british_guy_monolog < 1:
                british_guy_monolog = 1
                talking.play()
    if british_guy_monolog == 1:
        british_guy_text_1.y = -0.3
        if key_2 == 'enter':
            british_guy_monolog = 2
            british_guy_text_1.y = -50
            key_2 = None
            talking.play()
    if british_guy_monolog == 2:
        british_guy_text_2.y = -0.3
        if key_2 == 'enter':
            british_guy_monolog = 3
            british_guy_text_2.y = -50
            key_2 = None
            talking.play()
    if british_guy_monolog == 3:
        british_guy_text_3.y = -0.3
        if key_2 == 'enter':
            british_guy_monolog = 4
            british_guy_text_3.y = -50
            key_2 = None
            talking.play()
    if british_guy_monolog == 4:
        british_guy_text_4.y = -0.3
        if key_2 == 'enter':
            british_guy_monolog = 5
            british_guy_text_4.y = -50
            key_2 = None
    if british_guy_monolog == 5:
        if british_guy.rotation_y > -90:
            british_guy.rotation_y -= 1
        if british_guy.rotation_y <= -90:
            british_guy.x -= 0.04
            british_guy.y -= 0.0005
            british_guy.z -= 0.0005
        if british_guy.x <= -38:
            british_guy.visible = False
            british_guy.disable()
            british_guy_monolog = 6
    if british_guy_monolog == 6 or british_guy_monolog == 7:
        german_guy.y = 0
        if german_guy.z < 2:
            german_guy.z += 0.04
        if german_guy.z > -15:
            british_guy_monolog = 7
    if british_guy_monolog == 7:
        german_guy_text_1.y = -0.3
        if key_2 == 'enter':
            british_guy_monolog = 8
            german_guy_text_1.y = -50
            key_2 = None
            talking.play()
    if british_guy_monolog == 8:
        german_guy_text_2.y = -0.3
        if key_2 == 'enter':
            talking.play()
            british_guy_monolog = 9
            german_guy_text_2.y = -50
            self_text.y = -50
            key_2 = None
            german_guy.visible = False
            german_guy.y = -50
            white_flag_2.visible = False
            white_flag_1.visible = False
            at_machine_gun = False
            football_start = True
            player.x = 3
            player.z = -15
            player.y = 3


def football_ball():
    global ball, player, ball_speed_x, ball_speed_z, old_player_x, old_player_z, key_2, german_goal, british_goal, football_goal_british, football_goal_germans
    global ball_going_to_player, ball_place_to_go_to, reset_positions_player, british_end, german_end
    ball.x += ball_speed_x
    ball.z += ball_speed_z
    if british_goal >= 10:
        player.x = -120
        player.y = -50
        player.disable()
        british_end.y = 0
    if german_goal >= 10:
        player.x = -120
        player.y = -50
        player.disable()
        german_end.y = 0
    if ball.x > 17 and ball.z-2 < football_goal_germans.z < ball.z+2:
        british_goal += 1
        ball.x = 0
        ball.z = -10
        reset_positions_player = football_players_id
        ball_going_to_player = False
        ball_speed_x = 0
        ball_speed_z = 0
        player.x = 3
        player.z = -15
        player.y = 3
    if ball.x < -17 and ball.z-2 < football_goal_british.z < ball.z+2:
        german_goal += 1
        ball.x = 0
        ball.z = -10
        reset_positions_player = football_players_id
        ball_going_to_player = False
        ball_speed_x = 0
        ball_speed_z = 0
        player.x = 3
        player.z = -15
        player.y = 3
    if ball.z > -2 or ball.z < -17 or ball.x > 18 or ball.x < -18:
        ball.x = 0
        ball.z = -10
        reset_positions_player = football_players_id
        ball_going_to_player = False
        ball_speed_x = 0
        ball_speed_z = 0
        player.x = 3
        player.z = -15
        player.y = 3
    if ball_going_to_player:
        if ball_place_to_go_to.x > ball.x:
            ball_speed_x = 0.5
        if ball_place_to_go_to.x < ball.x:
            ball_speed_x = -0.5
        if ball_place_to_go_to.z > ball.z:
            ball_speed_z = 0.5
        if ball_place_to_go_to.z < ball.z:
            ball_speed_z = -0.5
        if ball.x - 1 < ball_place_to_go_to.x < ball.x + 1 and ball.z - 1 < ball_place_to_go_to.z < ball.z + 1:
            ball_going_to_player = False
            ball_speed_x = 0
            ball_speed_z = 0
    if ball_speed_x > 0:
        ball_speed_x -= 0.02
    if ball_speed_x < 0:
        ball_speed_x += 0.02
    if ball_speed_z > 0:
        ball_speed_z -= 0.02
    if ball_speed_z < 0:
        ball_speed_z += 0.02
    if ball_speed_x-0.1 <= 0 <= ball_speed_x+0.1:
        ball_speed_x = 0
    if ball_speed_z-0.1 <= 0 <= ball_speed_z+0.1:
        ball_speed_z = 0
    if ball.x-2 < player.x < ball.x+2 and ball.z-2 < player.z < ball.z+2:
        ball_speed_x = player.x - old_player_x
        ball_speed_z = player.z - old_player_z
        ball_going_to_player = False
    if ball.x-2 < player.x < ball.x+2 and ball.z-2 < player.z < ball.z+2 and key_2 == 'left mouse down':
        ball_speed_x = player.x - old_player_x
        ball_speed_z = player.z - old_player_z
        ball_speed_x = ball_speed_x * 20
        ball_speed_z = ball_speed_z * 20
        ball_going_to_player = False


def update():
    global generate, start_button, exit_button, key_2, ground, ground_2, ground_3, sun, player, treeline, game_cycle, ball, old_player_x, old_player_z, football_goal_british
    global football_goal_germans, goal_counter, football_players_id, machinegun_1, machinegun_2, sprinting, stamina, football_started, football_start, controls_list
    global british_guy, german_guy, generating, white_flag_1, white_flag_2, walking
    if game_cycle:
        if not walking.playing:
            if key_2 == 'w' or key_2 == 'w down':
                walking.play()
            if key_2 == 'a' or key_2 == 'a down':
                walking.play()
            if key_2 == 's' or key_2 == 's down':
                walking.play()
            if key_2 == 'd' or key_2 == 'd down':
                walking.play()
        starting_scene()
        if player.y < -3:
            player.y = 5
        if football_started:
            goal_counter.text = 'Britové:{}     Němci:{}'.format(british_goal,german_goal)
            goal_counter.y = -0.3
            football_ball()
        old_player_x = player.x
        old_player_z = player.z
        loading_text.y = -50
        white_flag_2.position = white_flag_1.position
        white_flag_1.position = german_guy.position
        white_flag_1.y = german_guy.y + 2
        if stamina < 100:
            stamina += 1
        if key_2 == 'left shift' and stamina > 0:
            sprinting = True
        if key_2 == 'left shift up':
            sprinting = False
        if sprinting and stamina > -50:
            player.speed = 10
            stamina -= 5
        if not sprinting:
            player.speed = 5
        if stamina < -50:
            sprinting = False
        if football_start:
            football_goal_british = Entity(model='goal_2',collider='mesh',texture='goal_texture_british', scale=0.2,x=-18,z=-10,rotation_y=180)
            football_goal_germans = Entity(model='goal_2', collider='mesh',texture='goal_texture_german', scale=0.2, x=18,z=-10)
            ball = Entity(model='ball',texture='ball_texture',scale=0.5,y=1,z=-10)
            goal_counter.y = -0.3
            ball.shader = lit_with_shadows_shader
            football_goal_british.shader = lit_with_shadows_shader
            football_goal_germans.shader = lit_with_shadows_shader
            football_started = True
            football_start = False
            football_players_id += 1
            football_players.append(
                Footballer(team=1, defender=True, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.red, x=-16,
                           z=-15))
            football_players_id += 1
            football_players.append(
                Footballer(team=1, defender=True, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.red, x=-16,
                           z=-5))
            football_players_id += 1
            football_players.append(
                Footballer(team=1, defender=False, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.blue, x=-3,
                           z=-15))
            football_players_id += 1
            football_players.append(
                Footballer(team=2, defender=True, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.orange, x=16,
                           z=-15))
            football_players_id += 1
            football_players.append(
                Footballer(team=2, defender=True, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.orange, x=16,
                           z=-5))
            football_players_id += 1
            football_players.append(
                Footballer(team=2, defender=False, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.green, x=3,
                           z=-15))
            football_players_id += 1
            football_players.append(
                Footballer(team=2, defender=False, id=football_players_id, model='cube',visible=False, scale_y=4, color=color.green, x=3,
                           z=-5))
    if generating:
        ground = Entity(model='trench', collider='mesh', scale_x=15, scale_z=10, scale_y=15, texture='ground_texture')
        ground_2 = Entity(model='trench', collider='mesh', x=29, scale_x=15, scale_z=10, scale_y=15,
                          texture='ground_texture')
        ground_3 = Entity(model='trench', collider='mesh', x=-29, scale_x=15, scale_z=10, scale_y=15,
                          texture='ground_texture')
        treeline = Entity(model='treeline',collider='mesh',scale_y=11,scale_x=13,y=-2,scale_z=10,texture='treeline_texture')
        machinegun_1 = Entity(model='machinegun1',texture='machinegun_1_texture',scale=0.1,x=-7.6,z=5.8,collider='mesh')
        machinegun_2 = Entity(model='machinegun_2', texture='machinegun_2_texture', scale=0.1,x=-7.6,z=5.8,collider='mesh')
        british_guy = BritishSoldier(model='british_soldier_uniform',texture='british_uniform',scale=1,collider='mesh',shader=lit_with_shadows_shader,z=7.8,x=-12.9,y=-2,rotation_y=90)
        german_guy = GermanSoldier(model='german_soldier_uniform',texture='german_torso',scale=1,shader=lit_with_shadows_shader,z=-27,x=-5,y=-5,collider='mesh')
        white_flag_1 = Entity(model='white_flag2',scale=0.1,collider='mesh',shader=lit_with_shadows_shader,color=color.white,rotation_y=90)
        white_flag_2 = Entity(model='white_flag_2',scale=0.1,collider='mesh',color=color.gray,shader=lit_with_shadows_shader)
        sun = DirectionalLight(y=4, z=3, shadows=True)
        player = FirstPersonController()
        player.y = 7
        player.x = -2
        player.z = 8
        player.rotation_y = -90
        machinegun_1.shader = lit_with_shadows_shader
        machinegun_2.shader = lit_with_shadows_shader
        treeline.shader = lit_with_shadows_shader
        ground.shader = lit_with_shadows_shader
        ground_2.shader = lit_with_shadows_shader
        ground_3.shader = lit_with_shadows_shader
        game_cycle = True
        generating = False
    if generate:
        generating = True
        generate = False
    if exit_button.hovered and key_2 == 'left mouse down':
        exit()
        quit()
    if credits_button.hovered and key_2 == 'left mouse down':
        controls_button.visible = False
        exit_button.visible = False
        start_button.visible = False
        credits_button.visible = False
        credits_list.y = 0
        back_button.y = -0.3
    if controls_button.hovered and key_2 == 'left mouse down':
        controls_button.visible = False
        exit_button.visible = False
        start_button.visible = False
        credits_button.visible = False
        controls_list.y = 0
        back_button.y = -0.3
    if back_button.hovered and key_2 == 'left mouse down':
        controls_button.visible = True
        exit_button.visible = True
        start_button.visible = True
        credits_button.visible = True
        back_button.y = -50
        credits_list.y = -50
        controls_list.y = -50
    if start_button.hovered and key_2 == 'left mouse down':
        starting_screen.visible = False
        starting_screen.y = -50
        starting_screen.disable()
        controls_button.visible = False
        controls_button.disable()
        exit_button.visible = False
        exit_button.disable()
        start_button.visible = False
        start_button.disable()
        credits_button.visible = False
        credits_button.disable()
        loading_text.y = 0
        generate = True


def input(key):
    global key_2, sprinting
    key_2 = key
    if key == 'escape':
        exit()
        quit()

window.windowed_size = 0.03
#window.aspect_ratio = 1.333
window.update_aspect_ratio()
app.run()
